'''
JSON-Publisher
=============================
client.publish (sequentielles Publish) und
publish.multiple(msgs,...)
veröffentlicht ein "Sammel"-Topic mit client.publish(), das vom Subscriper 
als JSON-Objekt empfangen wird.

=> Dieses Skript setzt "subscriber_3_json.py"  oder
   "subscriber_3_json_mDB_2.py" voraus

'''


import time

import paho.mqtt.client as mqtt
import paho.mqtt.publish as publish
import numpy as np
import json

def on_connect(client, userdata, flags, rc):
    print("Connected with result code " + str(rc))

# Parameterblock
mq_host = "127.0.0.1"        # lokaler PC
# mq_host = "172.18.45.150"    # Labor-Server
mq_topic = "test_172"   # letzte IP-Adr-Nr

client = mqtt.Client()
client.on_connect = on_connect

client.connect(mq_host, 1883, 60)

client.loop_start()

t = 0.0
while True:
    time.sleep(1)
    t = t + 0.01
    # python-dict beschreibt den Daten-Block (payload)
    PL = {"cos":np.cos(t),
        "cos2":np.cos(t)*2,
        "ts":time.time()
        }
    # Umwandeln in ein json-Objekt
    jPL = json.dumps(PL)
    # versenden (publish)
    client.publish(topic=mq_topic, payload = jPL)
    print(jPL)
                   
    